//Phantasma
//Version 0.02
#include "stdafx.h"
#include <iostream>
#include <cmath>
#include <cstdlib>
#include <string>
#include "windows.h"
#include <time.h>
#include "graphics.h"
using namespace std;
void pause(int option)
{
	char pauseVariable;
	if(option==0)
		system("PAUSE");
	if(option==1)
		system("PAUSE>NUL");
	if(option==2){
		cout<<"Press any key and enter to continue..."<<endl;
		cin>>pauseVariable;
	}
	return;
}

void brk(int lines)
{
	for(int i=0;i<lines;i++)
	{
		cout<<endl;
	}
}
void cls()
{
	system("cls");
}
int rng(int sides)
{
	int out=rand() % sides + 1;
	return out;
}
void disp(const char text[32],int length,short delay)
{
	for(int i=0;i<length;i++)
	{
		cout<<text[i];
		Sleep(delay);
	}
	cout<<endl;
}

void screenFlash(){
	//sequence F 7 8 7 F
	//bg,tx
	int dly=25;
	system("COLOR F0");
	Sleep(dly);
	system("COLOR 70");
	Sleep(dly);
	system("COLOR 80");
	Sleep(dly);
	system("COLOR 70");
	Sleep(dly);
	system("COLOR F0");
	Sleep(dly);
	system("COLOR 70");
	Sleep(dly);
	system("COLOR 80");
	Sleep(dly);
	system("COLOR 08");
	Sleep(dly);
	system("COLOR 07");
	Sleep(dly);
	system("COLOR 0F");
	return;
}
void loadGame(){
	cls();
	cout<<"Incomplete function."<<endl;
	pause(0);
	return;
}
void setup(){
	cls();
	cout<<"Color schemes:"<<endl;
	brk(1);
	pause(0);
	return;
}
void readMe(){
	cls();
	disp("P H A N T A S M A",18,125);
	cout<<" v0.02 Build 04.14.2017"<<endl;
	cout<<"Copyright 2017 AiO Softworks"<<endl;
	brk(1);
	cout<<"Credits go to:"<<endl;
	cout<<" Programming	- FAMICOMASTER"<<endl;
	cout<<" Graphics	- SkipperDMudkipz"<<endl;
	cout<<" Maps		- Hungrydurp"<<endl;
	cout<<" Story		- TheArkAngel"<<endl;
	cout<<" Sounds		- Churro"<<endl;
	brk(1);
	pause(0);
	return;
}

int quizGender(){
	char gender;
	cls();
	cout<<"First: Are you a male or a female?"<<endl;
	cout<<"Type M or F..."<<endl<<"]";
	cin>>gender;
	switch(gender){
		case 'm':
			return 0;
		case 'M':
			return 0;
		case 'f':
			return 1;
		case 'F':
			return 1;
		default:
			return 2;
	}
}

int quizRace(){
	cls();
	char race;
	cout<<"Choose your race from the list below:"<<endl;
	Sleep(10);
	cout<<" 1. Human"<<endl;
	Sleep(5);
	cout<<" 2. Elven"<<endl;
	Sleep(5);
	cout<<" 3. Dwarven"<<endl;
	Sleep(5);
	cout<<" 4. Goblin"<<endl;
	Sleep(1);
	cout<<"]";
	cin>>race;
	switch(race){
		case '1':
			return 0;
		case '2':
			return 1;
		case '3':
			return 2;
		case '4':
			return 3;
		default:
			return 4;
	}
}
int quizClass(){
	cls();
	char pclass;
	cout<<"Choose your class from the list below:"<<endl;
	Sleep(10);
	cout<<" 1. Sorcerer"<<endl;
	Sleep(5);
	cout<<" 2. Warrior"<<endl;
	Sleep(5);
	cout<<" 3. Cleric"<<endl;
	Sleep(5);
	cout<<" 4. Archer"<<endl;
	Sleep(5);
	cout<<" 5. Defender"<<endl;
	Sleep(5);
	cout<<" 6. Rider"<<endl;
	Sleep(1);
	cout<<"]";
	cin>>pclass;
	switch(pclass){
		case '0':
			return 6;
		case '1':
			return 0;
		case '2':
			return 1;
		case '3':
			return 2;
		case '4':
			return 3;
		case '5':
			return 4;
		case '6':
			return 5;
		default:
			return 7;
	}
	return 0;
}
void newGame(){
	int gender;
	int race;
	int pclass;
	char name[16];
	cls();
	while(true){
		gender=quizGender();
		if(gender==2)
			gender=quizGender();
		else
			break;
	}
	brk(1);
	while(true){
		race=quizRace();
		if(race==4)
			race=quizRace();
		else
			break;
	}
	brk(1);
	while(true){
		pclass=quizClass();
		if(pclass==7)
			pclass=quizClass();
		else
			break;
	}
	brk(1);
	cout<<"Finally, the most difficult question..."<<endl;
	cout<<"What shall your name be?"<<endl<<"]";
	cin>>name;
	brk(1);
	pause(0);
	cls();
	disp("Put story here...",17,25);
	brk(1);
	pause(0);
	cls();
	cout<<"Ready to start your journey?"<<endl;
	Sleep(500);
	disp(". . .",6,500);
	cout<<"Well too bad!"<<endl;
	pause(0);
	cls();
	screenFlash();
	return;
}
int title()
{
	char a;
	cls();
	disp("P H A N T A S M A",18,50);
	screenFlash();
	cout<<" v0.02  Build 04.14.2017"<<endl;
	cout<<"Copyright 2017 AiO Softworks"<<endl;
	brk(1);
	cout<<"Press a key and enter to play!"<<endl;
	cout<<" 1. New Game"<<endl;
	cout<<" 2. Load Game"<<endl;
	cout<<" 3. Colors"<<endl;
	cout<<" 4. Readme"<<endl;
	cout<<" 5. Exit"<<endl;
	cout<<"]";
	cin>>a;
	switch(a){
		case '0':
			return 2;
		case '1':
			newGame();
			break;
		case '2':
			loadGame();
			break;
		case '3':
			setup();
			break;
		case '4':
			readMe();
			break;
		case '5':
			return 1;
		case '6':
			return 3;
		case '7':
			return 4;
		default:
			return 0;
	}
}

int main(){
	//error handler
	int returnValue;
	while(true){
		returnValue=title();
		if(returnValue==0){
			//Reset pointer
		}
		if(returnValue==1)
			break;
		if(returnValue==2){
			cls();
			cout<<"Tried to enter debug mode"<<endl;
			pause(0);
			break;
		}
		if(returnValue==3){
			cls();
			system("COLOR C0");
			cout<<"An error occurred!"<<endl;
			brk(1);
			cout<<"Press any key to exit the program..."<<endl;
			pause(1);
			break;
		}
	}
	return 0;
}